<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace AdminModule;

class Albummanager extends Base {
    protected $table = 'albums_images';           
    public $location;
    
    const SAVE_STATE_ADDED = 1;
    const SAVE_STATE_REWRITED = 2;
    
    public function __construct(\DibiConnection $connection)
    {
        $this->db = $connection;
        $this->location = "albums";
    }    
    
    public function getTable(){
      return "albums";
    }
    
    private $albumid = null;
    
    public function setAlbumID($id){
       $this->albumid = $id;
    }
    public function getAlbumID(){
       return $this->albumid;
    }
    
    
    public function save($file){
        if($file->file->error) return 0;         
        $data = array(
             "file_name"=>$file->file->name,
             "users_id"=>$file->uploader,
             "albums_id"=>$file->albums_id,
             "time"=>time()
        );  
        
        $rewrited = false;        
        if(file_exists(WWW_DIR."/".$this->location."/".$file->albums_id."/".$file->file->name))
        {
          if($file->rewrite) $rewrited = true;
          else throw new \Exception("<strong>Fotografie ".$file->file->name." již existuje</strong>. Pokud se jedná o novější verzi, máte následující možnosti:
          <ul>
            <li>odstraňte prosím starou verzi a nahrajte soubor znovu, NEBO</li>
            <li>zaškrtněte prosím políčko pro přepis fotografií a nahrajte fotografii znovu.</li>
          </ul>  
          ");
        }  
        
        if(!is_writable(WWW_DIR."/".$this->location."/".$file->albums_id."/"))
          throw new \Exception("Adresář ".WWW_DIR."/".$this->location."/".$file->albums_id."/"." je chráněn proti zápisu. Proto nelze soubor nahrát.");     
           
        $file->file->move(WWW_DIR."/".$this->location."/".$file->albums_id."/".$file->file->name);     
                
        $this->db->query("DELETE FROM %n WHERE file_name=%s", $this->table, $file->file->name);
        $this->db->query("INSERT INTO %n", $this->table, $data);
        
        if($rewrited) return self::SAVE_STATE_REWRITED;
        else return self::SAVE_STATE_ADDED;
    } 
    
    public function update($data){
        if(!isset($data->id)) return false;
        else {
          $this->db->query("UPDATE %n",$this->table," SET ", $data, " WHERE id=%i", $data->id);
          return true;
        }
    }      
    
    public function getDataSource($filters=null, $order=null, $datasource = null){
        $concat = "CONCAT('http://".$_SERVER['HTTP_HOST']."/".$this->location."/',F.albums_id,'/',F.file_name) AS url";
        $datasource = $this->db->dataSource("SELECT $concat, U.username,F.* FROM %n F,users U WHERE F.users_id=U.id AND F.albums_id=%i", $this->table, $this->getAlbumID());      
        return parent::getDataSource($filters, $order, $datasource);
    }
    
    public function delete($id){
        $fileName = $this->db->fetchSingle("SELECT file_name FROM %n WHERE id=%i", $this->table, $id);
        if(!$fileName) return false;
        if(file_exists(WWW_DIR."/".$this->location."/".$fileName)){
          unlink(WWW_DIR."/".$this->location."/".$fileName);
        }
        $this->db->query("DELETE FROM %n WHERE id=%i", $this->table, $id);
        return true;
    }
    
    public function getAlbumIDByPhotoID($photoid){
        return $this->db->fetchSingle("SELECT albums_id FROM %n WHERE id=%i", $this->table, $photoid);
    }
    
    public function getById($id){
        $data = $this->db->fetch("SELECT * FROM %n WHERE id=%i", $this->table, $id);
        if(!$data) return array();
        else return $data;
    }
    
    public function getFileNameByID($photoid){
        return $this->db->fetchSingle("SELECT file_name FROM %n WHERE id=%i", $this->table, $photoid);
    }
    
    
}