<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */

namespace AdminModule;

use \Nette\Security as NS;

class Auth extends Base implements NS\IAuthenticator {
    protected $table = 'users';
      
    public function __construct(\DibiConnection $connection)
    {
        parent::__construct($connection);
    }
    
    //ahtorizator
    public function authenticate(array $credentials) {
        list($username, $password) = $credentials;
        $row = $this->db->fetch("SELECT * FROM %n WHERE (username=%s OR email=%s)", $this->table, $username, $username);
        if (!$row || $row->password !== $this->hashPassword($password)) throw new \Nette\Security\AuthenticationException("Špatné heslo nebo jméno.", self::INVALID_CREDENTIAL);
        if($row->deleted == true) throw new \Nette\Security\AuthenticationException("Uživatelské jméno bylo deaktivováno.");
        $this->db->query("UPDATE %n SET %a WHERE id=%i",
                                                        $this->table,
                                                        array(
                                                              'last_login' => time(),
                                                              'login_count' => $row->login_count+1,
                                                              'last_ip' => $_SERVER['REMOTE_ADDR']
                                                              ),
                                                        $row->id);
        unset($row->password);
        return new \Nette\Security\Identity($row->id, $row->toArray());
    }
    
    private function hashPassword($password) {
        return md5($password);
    } 
    
    public static function getUserIdByName($db,$username){
        return $db->fetchSingle("SELECT id FROM users WHERE username=%s OR email=%s",  $username, $username);
    }         
}