<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace AdminModule;

abstract class Base extends \Nette\Object {
    protected $db;
    public function __construct(\DibiConnection $connection)
    {
        $this->db = $connection;
    }    
    
    public function getTable(){
      return $this->table;
    }
    
    public function getDataSource($filters=null, $order=null, $datasource=null){
        if($datasource===null) $datasource = $this->db->dataSource("SELECT * FROM %n ORDER BY id", $this->table);  
  
        if($filters!==null){
          foreach($filters as $filter){
            $datasource = $datasource->where($filter);
          }
        }
        
        if($order!==null){
          foreach($order as $ord){
            $datasource = $datasource->orderBy($ord);
          }
        }
        
        return $datasource->fetchAll();
    }    
    
    public function stripHTMLInArray($array){
        if(!is_array($array)) return null;
        $new_array = array();
        foreach($array as $key=>$value){
          $new_array[$key] = strip_tags($value);
        }
        return $new_array;
    } 
    
    public function duplicate($id, $data){
      $record = $this->db->fetch("SELECT * FROM %n WHERE id=%i", $this->table, $id);
      if(isset($record->id)) unset($record->id);
      if(isset($record->deleteable)) unset($record->deleteable);  
      if(isset($record->editable)) unset($record->editable);     
      $record = (array) $record;
      foreach($data as $key=>$value){
        $record["$key"] = $value;
      }
      $this->db->query("INSERT INTO %n", $this->table, $record);
      return true;
    }
    
    public function getImageSRCFromHTML($html){                 
      preg_match_all("<img.+?src=[\"'](.+?)[\"'].*?>", $input, $result);   // <?php // fix zvýrazňovače
      return $result;
    }
    
    public function isBase64($str){
      if(strpos("data:image/png;base64", $str) === false) return false;
      else return true;
    }
    
    public function saveBase64($base64){
       $data = str_replace('data:image/png;base64,', '', $base64);   
       $data = str_replace(' ', '+', $data); 
       $data = base64_decode($data);
       $fileName = $this->location."/".$this->randomFileName(32);
       $fileLocation = WWW_DIR."/".$fileName.'.png';  
       $success = file_put_contents($fileLocation, $data);     
       return "/".$fileName; 
    }    
    
    private function randomFileName($length) {         
        $key = '';            
        do{
          $key = '';
          $keys = array_merge(range(0, 9), range('a', 'z'));
          for ($i = 0; $i < $length; $i++) {$key .= $keys[array_rand($keys)];}       
        } while(file_exists(WWW_DIR."/".$this->location));        
        return $key;
    }
    
    
}

