<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace AdminModule;

class Categories extends Base {
    protected $table = 'categories';  
       
    public function getById($id){
        $data = $this->db->fetch("SELECT * FROM %n WHERE id=%i", $this->table, $id);
        if(!$data) return array();
        else return $data;
    }
        
    public function insert($data)
    {                    
        if($this->db->fetchSingle('SELECT id FROM %n P WHERE P.name LIKE %s', $this->table,$data->name)>0) return false;
        $result = $this->db->query("INSERT INTO %n", $this->table, $data);
        return $this->db->getInsertId();
    }
    
    public function update($data){
        if(!isset($data->id)) return false;
        else {
          $this->db->query("UPDATE %n",$this->table," SET ", $data, " WHERE id=%i", $data->id);
          return true;
        }
    }
    
    public function delete($id){
        $this->db->query("DELETE FROM %n", $this->table, " WHERE id=%i AND deleteable=1", $id);
    }
    
    public function getCategories(){
        return $this->db->query("SELECT id,name FROM %n", $this->table)->fetchPairs("id", "name");
    }  
  
    public function assignCategories($insertID, $categories, $resource){
        $table = $resource."_".$this->table;
        $this->db->query("DELETE FROM %n WHERE ".$resource."_id=%i", $table, $insertID);
        foreach($categories as $category){
           if($category->categories_id==0) continue;
           $category[$resource."_id"] = $insertID;
           
           $this->db->query('INSERT INTO %n', $table, $category);
        }   
        return true;
    }  
}
