<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace AdminModule;

class Globals extends Base {
    protected $table = 'globals';  
       
    public function getById($id){
        $data = $this->db->fetch("SELECT * FROM %n WHERE id=%i", $this->table, $id);
        if(!$data) return array();
        else return $data;
    }
    
    public function getDataSource($filters=null, $order=null, $datasource=null){
        $datasource = $this->db->dataSource("SELECT *, CONCAT('{globalVar \"', %n ,'\"}') AS macro  FROM %n", "key", $this->table);  
        return parent::getDataSource($filters, $order, $datasource);
    }
    
    
    public function insert($data)
    {
        $d = $data;
        unset($d->id);                       
        if($this->db->fetchSingle('SELECT id FROM %n G WHERE G.key LIKE %s', $this->table,$data->key)>0) return false;
        $result = $this->db->query("INSERT INTO %n", $this->table, $d);
        return $this->db->getInsertId();
    }
    
    public function update($data){
        if(!isset($data->id)) return false;
        else {
          $this->db->query("UPDATE %n",$this->table," SET ", $data, " WHERE id=%i", $data->id);
          return true;
        }
    }
    
    public function delete($id){
        $this->db->query("DELETE FROM %n", $this->table, " WHERE id=%i", $id);
    }
    
    public function isDeleteable($id){
        return $this->db->fetchSingle("SELECT deleteable FROM %n", $this->table, "WHERE id=%i", $id);
    }
    
    public function isEditable($id){
        return $this->db->fetchSingle("SELECT editable FROM %n", $this->table, "WHERE id=%i", $id);
    }
    
}
