<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace AdminModule;

class News extends Base {
    protected $table = 'news';  
    public $categories = null;
    
    public function __construct(\DibiConnection $connection)
    {
        $this->categories = new Categories($connection);
        parent::__construct($connection);
    }  
    
    public function getDataSource($filters=null, $order=null, $datasource=null){
        $datasource = $this->db->dataSource("SELECT N.*,U.username FROM %n N, users U WHERE N.users_id=U.id", $this->table);  
        return parent::getDataSource($filters, $order, $datasource);
    } 
    
    public function getById($id){
        $data = $this->db->fetch("SELECT * FROM %n WHERE id=%i", $this->table, $id);
        if(!$data) return array();
        else return $data;
    }
    
    public function getCategoriesByID($id){
        $data = $this->db->fetchAll("SELECT * FROM %n WHERE news_id=%i", $this->table.'_categories', $id);
        if(!$data) return array();
        else return $data;
    }
        
    public function insert($data)
    {
        unset($data->id); 
        $categories = $data->categories;
        unset($data->categories);
        $this->db->begin();                   
        if($this->db->fetchSingle('SELECT id FROM %n P WHERE P.title LIKE %s', $this->table,$data->title)>0) return false;
        $result = $this->db->query("INSERT INTO %n", $this->table, $data);
        $insertID = $this->db->getInsertId();
        $this->categories->assignCategories($insertID, $categories, $this->table);
        $this->db->commit();  
        return $insertID;
    }
    
    public function update($data){
        
        $categories = $data->categories;
        unset($data->categories);
          
        if(!isset($data->id)) return false;
        else {
          $this->categories->assignCategories($data->id, $categories, $this->table);
          
          $this->db->query("UPDATE %n",$this->table," SET ", $data, " WHERE id=%i", $data->id);
          return true;
        }
    }
    
    public function toggleVisibility($id){                    
        if(!isset($id)) return false;            
        $this->db->query("UPDATE %n SET visible=1-visible WHERE id=%i", $this->table, $id); 
        return true;    
    }
    
    public function delete($id){
        $this->db->query("DELETE FROM %n", $this->table, " WHERE id=%i", $id);
    }
    
    
    
}
