<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace AdminModule;

class Uploader extends Base {
    protected $table = 'files';           
    public $location;
    
    const SAVE_STATE_ADDED = 1;
    const SAVE_STATE_REWRITED = 2;
    
    public function __construct(\DibiConnection $connection)
    {
        $this->db = $connection;
        $this->location = "uploads";
    }   
    
    public function exists($file){
       if(file_exists(WWW_DIR."/".$this->location."/".$file->file->name)) {
          return true;
       }
       else {
          return false;
       }
    } 
    
    public function getFileID($file){
      return $this->db->fetchSingle("SELECT id FROM %n WHERE file_name=%s", $this->table, $file->file->name);
    }
    
    public function save($file){
        if($file->file->error) return 0;         
        $data = array(
             "file_name"=>$file->file->name,
             "users_id"=>$file->uploader,
             "time"=>time()
        );  
        
        $rewrited = false;        
        if(file_exists(WWW_DIR."/".$this->location."/".$file->file->name))
        {
          if($file->rewrite) $rewrited = true;
          else throw new \Exception("<strong>Soubor ".$file->file->name." již existuje</strong>. Pokud se jedná o novější verzi, máte následující možnosti:
          <ul>
            <li>odstraňte prosím starou verzi a nahrajte soubor znovu, NEBO</li>
            <li>zaškrtněte prosím políčko pro přepis souborů a nahrajte soubor znovu.</li>
          </ul>  
          ");
        }  
        
        if(!is_writable(WWW_DIR."/".$this->location."/"))
          throw new \Exception("Adresář ".WWW_DIR."/".$this->location."/"." je chráněn proti zápisu. Proto nelze soubor nahrát.");     
           
        $file->file->move(WWW_DIR."/".$this->location."/".$file->file->name);
        
        $this->db->query("DELETE FROM %n WHERE file_name=%s", $this->table, $file->file->name);
        $this->db->query("INSERT INTO %n", $this->table, $data);
        
        if($rewrited) return self::SAVE_STATE_REWRITED;
        else return self::SAVE_STATE_ADDED;
    } 
    
    public function getDataSource($filters=null, $order=null, $datasource = null){
        $concat = "CONCAT('http://".$_SERVER['HTTP_HOST']."/".$this->location."/',F.file_name) AS url";
        $datasource = $this->db->dataSource("SELECT $concat, U.username,F.* FROM %n F,users U WHERE F.users_id=U.id", $this->table);      
        return parent::getDataSource($filters, $order, $datasource);
    }
    
    public function delete($id){
        $fileName = $this->db->fetchSingle("SELECT file_name FROM %n WHERE id=%i", $this->table, $id);
        if(!$fileName) return false;
        if(file_exists(WWW_DIR."/".$this->location."/".$fileName)){
          unlink(WWW_DIR."/".$this->location."/".$fileName);
        }
        $this->db->query("DELETE FROM %n WHERE id=%i", $this->table, $id);
        return true;
    }
    
    
}