<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace AdminModule;

class Users extends Base {
    protected $table = 'users';  
       
    public function getById($id){
        return $this->db->fetch("SELECT * FROM %n WHERE id=%i", $this->table, $id);
    }
    
    public function getDataSource($filters=null, $order=null, $datasource=null){
        $datasource = $this->db->dataSource("SELECT *,last_login as time, id AS users_id FROM %n WHERE deleted=0", $this->table);  
        return parent::getDataSource($filters, $order, $datasource);
    }
    
    public function insert($data)
    {
        unset($data->id);  
        $data->password = $this->hashPassword($data->password); 
        if($this->db->fetchSingle('SELECT id FROM %n U WHERE U.email LIKE %s OR U.username LIKE %s', $this->table,$data->email, $data->username)>0) return false;                 
        $result = $this->db->query("INSERT INTO %n", $this->table, $data);
        return $this->db->getInsertId();
    }
    
    public function update($data){
        if(!isset($data->id)) return false;
        $data->password = $this->hashPassword($data->password);
        $this->db->query("UPDATE %n",$this->table," SET ", $data, " WHERE id=%i", $data->id);
        return true;
    }
    
    private function hashPassword($password) {
        return md5($password);
    } 
    
    public function delete($id){
        return $this->db->query("UPDATE %n SET deleted=1 WHERE id=%i AND deleted=0", $this->table, $id);      
    }
    
    public function getFlags(){
        return $this->db->fetchAll("SELECT * FROM %n", "flags");
    }
    
    public function getResources(){
        return $this->db->fetchAll("SELECT * FROM %n", "resources");
    }
    
    public function getUserPermissions($userID){
        $result = $this->db->fetchAll("SELECT * FROM permissions WHERE users_id=%i", $userID);
        $permissions = array();
        foreach($result as $row){
          $permissions[$row["resources_id"]][$row["flags_id"]]=true;
        }
        return $permissions;
    }
    
    public function updateUserPermissions($userID, $data){
        $this->db->begin();
        $this->db->query("DELETE FROM permissions WHERE users_id=%i", $userID);
        foreach($data as $resourceID=>$flags){
          foreach($flags as $flagID=>$value){
             if($value==TRUE){
                $insert = array();
                $insert['users_id']=$userID;
                $insert['resources_id']=$resourceID;
                $insert['flags_id']=$flagID;
                $this->db->query("INSERT INTO permissions", $insert);                
             }
          }
        }
        $this->db->commit();
    }
}
