<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace AdminModule;

class Widgets extends Base {
    protected $table = 'widgets';  
       
    public function getById($id){
        $data = $this->db->fetch("SELECT * FROM %n WHERE id=%i", $this->table, $id);
        if(!$data) return array();
        else return $data;
    }
    
    public function getDataSource($filters=null, $order=null, $datasource=null){
        $datasource = $this->db->dataSource("SELECT *,CONCAT('{widget ',id,'}') AS macro FROM %n", $this->table);  
        return parent::getDataSource($filters, $order, $datasource);
    } 
    
    public function insert($data)
    {
        $d = $data;
        $d->stripped = $this->stripTags($data->value);
        unset($d->id);                       
        if($this->db->fetchSingle('SELECT id FROM %n G WHERE G.key LIKE %s', $this->table,$data->key)>0) return false;
        $result = $this->db->query("INSERT INTO %n", $this->table, $d);
        return $this->db->getInsertId();
    }
    
    public function update($data){
        if(!isset($data->id)) return false;
        else {
          $d = $data;
          $d->stripped = $this->stripTags($data->value);
          $this->db->query("UPDATE %n",$this->table," SET ", $d, " WHERE id=%i", $d->id);
          return true;
        }
    }
    
    public function delete($id){
        $this->db->query("DELETE FROM %n", $this->table, " WHERE id=%i", $id);
    }
    
    public function isDeleteable($id){
        return $this->db->fetchSingle("SELECT deleteable FROM %n", $this->table, "WHERE id=%i", $id);
    }
    
    public function isEditable($id){
        return $this->db->fetchSingle("SELECT editable FROM %n", $this->table, "WHERE id=%i", $id);
    }
       
    private function stripTags($value){
        $v = strip_tags($value);
        $v = str_replace("&nbsp;", " ", $v);
        $a = Array(
          "&scaron;"=>"š",
          "&Scaron;"=>"Š",
          "&yacute;"=>"ý",
          "&Yacute;"=>"Ý",
          "&aacute;"=>"á",
          "&Aacute;"=>"Á",
          "&iacute;"=>"í",
          "&Iacute;"=>"Í",
          "&eacute;"=>"é",
          "&Eacute;"=>"É",
        );
        $v = strtr($v, $a);
        $l = strlen($v);
        $v = substr($v, 0, 50);
        if($l!=strlen($v)) return $v."...";
        else return $v;
    } 
}
