<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */

namespace AdminModule;

use Nette\Application\UI\Presenter,
    Nette\Application\UI\Form,
    Nette\Utils\Strings;


class AuthPresenter extends BasePresenter {
   public function startup(){
       parent::startup();
   }

   public function renderLogout() {
      $this->user->logout(TRUE);
   }

   public function renderDefault($key){
       $this['login']->setDefaults(array('key' => $key));
   }

   public function login($form) {
      $data = $form->getValues();
      try {
            if ($data['remember']) $this->getUser()->setExpiration('+180 minutes', FALSE);
            else $this->getUser()->setExpiration('+60 minutes', TRUE);
            $this->user->login($data->username, $data->password);
            $this->logger->LogUserEvent($this->user->id, 1, "Přihlášení z ".htmlspecialchars($_SERVER['REMOTE_ADDR']), Logger::LOG_LEVEL_INFO, $this->user->id);   
            if ($data['key']) $this->restoreRequest($data['key']);
            if($data->password=="ZS1234"){
              $this->flashMessage("Změňte si prosím heslo u Vašeho uživatelského účtu.", "warning");
            }
            $this->redirect("Default:default");
      }
      catch (\Nette\Security\AuthenticationException $e)
      {
        $form->addError($e->getMessage());
        if(Auth::getUserIdByName($this->db,$data->username) != null){  // existujici uzivatel
          $this->logger->LogUserEvent(Auth::getUserIdByName($this->db,$data->username), 1, "Přístup odmítnut - ".htmlspecialchars($_SERVER['REMOTE_ADDR']), Logger::LOG_LEVEL_ERROR);
        }
        else { // neexistujici uzivatel
          $this->logger->LogEvent(1, "Přístup pro ".htmlspecialchars($data->username)." odmítnut - ".htmlspecialchars($_SERVER['REMOTE_ADDR']), Logger::LOG_LEVEL_WARNING);
        }           
      }
   }
   
   public function createComponent($name) {
      switch ($name) {
         case 'login':
            $form = New Form($this, $name);
            $form->addText('username', 'Uživatel')->addRule(Form::FILLED, 'Zadejte uživatelské jméno');
            $form['username']->getControlPrototype()->autofocus('autofocus');
            $form->addPassword('password', 'Heslo')->addRule(Form::FILLED, 'Zadejte heslo');
            $form->addCheckbox('remember', 'Zapamatovat');
            $form->addHidden('key');
            $form->addSubmit('send', 'Přihlásit');
            $form->onSuccess[] = callback($this, 'login');
            return $form;
      }
   }
}