<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
 
 /* TODO: duplikace záznamů. */
namespace AdminModule;

use Nette\Application\UI,
    Nette\Utils\Html;

use Nette\Diagnostics\Debugger;

abstract class BasePresenter extends UI\Presenter {
    /** @inject @var \DibiConnection */
    public $db;
    
    public $model;
    /** @inject @var \AdminModule\Authorizator */
    public $authorizator;
    /** @inject @var \AdminModule\Logger */
    public $logger; 
    
    
    /** @var string @persistent */
    public $lang = 'cs';
        
    protected $permissionName = NULL;
    protected $resourcesId = NULL; 
    
    public function startup() {        
        parent::startup();
        $user = self::getUser();
        $this->template->moduleName = "Neznámý modul";
        $this->template->actionName = "Neznámá akce";
        $this->template->user = $user->isLoggedIn() ? (object)$user->getIdentity()->roles : false;
        
        $this->template->authorizator = $this->authorizator;
                
        // Automatic $this->model instance creator
        $model = $this->ModelNameByClass(get_class($this)); // Gets model name from presenter Name
                     
        if(class_exists($model)){
          $this->model = new $model($this->db);
        }
       
        if(isset($this->translator)) {
          $this->translator->setCurrentLang($this->lang);
          //\Nette\Diagnostics\Debugger::addPanel(new \TranslationPanel($this->translator));
        }
        \Nette\Diagnostics\Debugger::addPanel(new \timerPanel());
    }
    
    public function beforeRender()
    {
      if(isset($this->translator))
        $this->template->setTranslator($this->translator);
    }
    
    private function ModelNameByClass($className, $strip=false){
        if($strip==true) $start = strpos($className, "\\")+1;
        else $start = 0;
        return substr($className, $start, -strlen("Presenter")); 
    } 

    
    public function generateURL($id, $action=null){
      if($action===null) $action="default";
      return "http://".$_SERVER['HTTP_HOST'].$this->link(':Front:'.$this->ModelNameByClass(get_class($this), true).':'.$action, array('id'=>$id));
    }
    
    public function debug($var, $die=false){
        \Nette\Diagnostics\Debugger::barDump($var);
        if($die==true)
        {
          die("<pre>".print_r($var, "\n")."</pre>");
        }
    }
}
