<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace AdminModule;
use Nette\Application\UI\Form,
    Nette\Utils\Strings,
    Tracy\Debugger;


class PermissionsPresenter extends SecurePresenter
{
    
    public function startup(){
        parent::startup();
        $this->template->moduleName='Oprávnění';
        $this->permissionName="PERMISSIONS";
        $this->model = new Users($this->db);
        $this->resourcesId=$this->authorizator->GetresourcesId($this->permissionName);
    }
    
    
    public function renderDefault() {
        $this->checkPermission("ACCESS");      
        $this->template->actionName='Přehled';
        $this->template->logs=$this->logger->GetLogForResource($this->resourcesId, Logger::LOG_LEVEL_INFO);
    }
    
   
    
    public function OnTestFormResponse($form){
      $data = $form->getValues();
      $userID = $data->id;
      unset($data->id);
      \Nette\Diagnostics\Debugger::barDump($data);
      $this->model->updateUserPermissions($userID, $data);
      $this->redirect("users:");
      return true;
    }
   
      private function createForm($id){
             $form = new Form;
             $form->addHidden("id")->setDefaultValue($id);
             $permissions = $this->model->getUserPermissions($id);
             $flags = $this->model->getFlags();
             $resources = $this->model->getResources();
             foreach($resources as $resource){
                $form->addGroup($resource->description);
                $res[$resource->id] = $form->addContainer($resource->id); 
                foreach($flags as $flag){
                    $element = $res[$resource->id]->addCheckbox($flag->id,$flag->description);
                    if(isset($permissions[$resource->id][$flag->id])) $element->setDefaultValue(TRUE);
                }              
             }
             return $form;
      }       
      public function createComponentTestForm($name){
          $id = $this->getParam("id");
          $form = $this->createForm($id);
          $form->onSuccess[] = callback($this, "OnTestFormResponse");
          $form->addSubmit('submit', 'Přidat'); 
          return $form;    
      }
}
