<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace AdminModule;  

abstract class SecurePresenter extends BasePresenter {
        
    /** @inject @var \Mobile_Detect */
    public $mobileDetect;
  
    public function startup() {
        parent::startup();
        if (!$this->user->isLoggedIn()) {
            $key = $this->storeRequest();
            $this->redirect("Auth:default",$key);
        }
        else {
          if($this->mobileDetect->isMobile()){
            $this->flashMessage("Omlouváme se, ale administrace není v současné době dostupná přes mobilní zařízení. Použijte prosím počítač.", "danger");
            $this->user->logout();
            $this->redirect("auth:");
          }
          else if($this->mobileDetect->isTablet()){
            $this->flashMessage("Administrace pro zařízení typu Tablet je pouze experimentální. Doporučujeme využít počítačového rozhraní.");
          }
        }
    }
    
    public function beforeRender(){
      $this->template->users_id = $this->user->id;
    }
    
    public function checkPermission($FlagName, $Redirect="default:"){
      if(!$this->authorizator->isAllowed($this->permissionName, $FlagName)){
            $this->flashMessage($this->authorizator->getErrorMessage(), "danger");
            $this->logger->LogUserEvent($this->user->id, $this->resourcesId, "Přístup odmítnut - ".$this->getName().":".$this->getAction(), Logger::LOG_LEVEL_ERROR, $this->user->id); 
            $this->redirect($Redirect);
        } 
    }

}