<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2015 Lukáš Zelenka [Xchos]
 * 
 */
namespace FrontModule;

class Album extends Base {
    protected $table = 'albums_images';           
    public $location = "albums";
    
    public function getTable(){
        return "albums";
    }
       
    
    public function fullPath($albumid, $fileName){
       return "/".$this->location."/".strval($albumid)."/".$fileName;
    }   
    
    public function getById($albumid){
        $data = $this->db->fetchAll("SELECT * FROM %n WHERE albums_id=%i", $this->table, $albumid);
        if($data === false) {
            //throw new \Nette\Application\BadRequestException("Fotografie $id nebyla nalezena!");
            return null;
        }        
        else {
            foreach($data as $id=>$photo){
              $data[$id]->path = $this->fullPath($albumid, $photo->file_name);
            }
            return $data;
        }
    }
    
    public function getAll(){
        $data = $this->db->fetch("SELECT * FROM %n", $this->table);
        if($data === false) {
            throw new \Nette\Application\BadRequestException("Žádné fotografie nebyly nalezeny v tomto albu");
            return null;
        }        
        else {
            return $data;
        }
    }
    
        
    public function getAlbumIDByPhotoID($photoid){
        return $this->db->fetchSingle("SELECT albums_id FROM %n WHERE id=%i", $this->table, $photoid);
    }
    
    
    public function getFileNameByID($photoid){
        return $this->db->fetchSingle("SELECT file_name FROM %n WHERE id=%i", $this->table, $photoid);
    }
    
    public function getLocation($file){
      return "/".$this->location."/".$file->albums_id."/".$file->name;
    }
    
      
}