<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace FrontModule;

class Navigations extends Base {
    public static $instance;

    public static function getInstance() {
        if (!isset(self::$instance)) self::$instance = new Navigations();
        return self::$instance;
    } 

    private $toSkip = array();

    private $layout;

    protected $table = 'navigations';  
    
    public static function getById($id){
        $instance = self::getInstance();
        $source = $instance->getSource($id);
        
        $instance->layout = $instance->getNavigationInfo($id);
        
        $order = $instance->getOrder($source);
        
        $render = $instance->render($instance->remakeSource($source), $order);
        
        return $render;
    }
    
    public function getNavigationInfo($id) {
        $instance = self::getInstance();
        return $instance->db->fetch("SELECT * FROM navigation WHERE id=%i", $id);
    }
    
    private function getSource($id){
      $instance = self::getInstance();
      return $instance->db->fetchAll("SELECT * FROM %n WHERE navigation_id=%i ORDER BY parent_id, pos_id", $instance->table, $id);
    }
    
    private function remakeSource($source){
      $newSource = array();
      foreach($source as $row){
          $newSource[$row->id]=$row;
      } 
      return $newSource;
    }
    
    private function SearchChild($source, $parentID){  
        $instance = self::getInstance();      
        $node = array();
        foreach($source as $row){                 
          if($row->parent_id==$parentID){
            if(isset($instance->toSkip[$parentID])) continue;
            $node[$row->id] = $instance->SearchChild($source, $row->id);
            $instance->toSkip[$row->id]=true;
          }
        }
        return $node;
    }

    private function getOrder($source){
        $instance = self::getInstance();      
        $node = array();
        foreach($source as $row){
          if(isset($instance->toSkip[$row->id])) continue;
          $node[$row->id] = $instance->SearchChild($source, $row->id);  
        }
        return $node;
    }
    
    private function renderChild($source, $order, $parentID){  
        $instance = self::getInstance();      
        $str = $instance->layout->child_ul_opening_tag;
        foreach($order as $id=>$row){
            if(!count($row)){
               $str.= $instance->layout->li_opening_tag.$instance->getLink($source, $id).$instance->layout->li_closing_tag;
            } else {
               $str.=$instance->layout->li_dropdown_opening_tag.$instance->getLink($source, $id, true)."".$instance->renderChild($source, $order[$id], $id).$instance->layout->li_closing_tag;               
            }
        }
        $str .=$instance->layout->ul_closing_tag;
        return $str;
    }
    
    private function render($source, $order){
        $instance = self::getInstance();      
        $str = $instance->layout->root_ul_opening_tag;
        foreach($order as $id=>$row){
            if(!count($row)){
               $str.= $instance->layout->li_opening_tag.$instance->getLink($source, $id).$instance->layout->li_closing_tag;
            } else {
               $str.=$instance->layout->li_dropdown_opening_tag.$instance->getLink($source, $id, true)."".$instance->renderChild($source, $order[$id], $id).$instance->layout->li_closing_tag;
            }
        }
        $str .=$instance->layout->ul_closing_tag;
        return $str;
    }
    
    private function getLink($source, $id, $dropdown = false){
        $instance = self::getInstance();      
        if($dropdown == true){
            return $instance->layout->a_dropdown_opening_tag." href='".$source[$id]['href']."'>".$source[$id]['content'].$instance->layout->a_closing_tag;
        }
        else {
            return $instance->layout->a_opening_tag." href='".$source[$id]['href']."'>".$source[$id]['content'].$instance->layout->a_closing_tag;
        }
    }
}
