<?php
/*
 * 
The MIT License (MIT)

Copyright (c) 2014 Lukáš Zelenka [Xchos]
 * 
 */
namespace FrontModule;

class News extends Base {
    protected $table = 'news'; 
    
    const ARCHIVE_CATEGORY_ID = 1;

        public function archiveNews($olderThan = -1, $categories_id = self::ARCHIVE_CATEGORY_ID){
        if($olderThan<0) {
            $olderThan = strtotime("first day of january " . date('Y'));
        }
        
        $old_news = $this->db->fetchAll("SELECT * FROM %n WHERE time<=%i", $this->table, $olderThan);
        foreach($old_news as $row){
            $this->db->query("INSERT INTO %n", $this->table."_categories", array("news_id"=>$row->id, "categories_id"=>$categories_id));
        }
        return true;
    }
    
    public function getById($id){
        
        $data = $this->db->fetch("SELECT * FROM %n WHERE id=%i", $this->table, $id);
        if($data === false) {
            throw new \Nette\Application\BadRequestException("Stránka nebyla nalezena!");
            return null;
        }        
        else {
            $data->categories = $this->getCategories($data->id);
            return $data;
        }
    }
    
    public function get($limit=-1, $offset=-1, $visibility=true){
        if($limit>-1 && $offset>-1){
            $data = $this->db->fetchAll("SELECT * FROM %n ORDER BY time DESC %lmt %ofs", $this->table, $limit, $offset);
        } else {
            $data = $this->db->fetchAll("SELECT * FROM %n ORDER BY time DESC", $this->table);
        }
        
        
        if($data === false){
            throw new \Exception("Nebyli nalezeny žádné novinky");            
        }
        else {
            foreach($data as $key => $row)
            {
                $row->categories = $this->getCategories($row->id);
                foreach($row->categories as $category)
                {
                    if($category->categories_id == self::ARCHIVE_CATEGORY_ID)
                    {                        
                        unset($data[$key]);
                    }   
                }
                if($row->visible == 0 && $visibility == true){
                  unset($data[$key]);
                }
            }
            return $data;            
        }
    }
    
   
    public function getArchive($limit=-1, $offset=-1){
        if($limit>-1 && $offset>-1){
            $data = $this->db->fetchAll("SELECT N.* FROM %n N,news_categories NC WHERE NC.news_id=N.id AND NC.categories_id=1 ORDER BY time DESC %lmt %ofs", $this->table, $limit, $offset);
        } else {
            $data = $this->db->fetchAll("SELECT N.* FROM %n N,news_categories NC WHERE NC.news_id=N.id AND NC.categories_id=1 ORDER BY time DESC", $this->table);
        }
        
        
        if($data === false){
            throw new \Exception("Nebyli nalezeny žádné novinky");            
        }
        else {
            foreach($data as $key => $row)
            {
                $row->categories = $this->getCategories($row->id);
                $row->archived = false;
                foreach($row->categories as $category)
                {
                    if($category->categories_id == self::ARCHIVE_CATEGORY_ID)
                    {                        
                        $row->archived = true;
                    }   
                }
                if($row->archived == false){
                    unset($data[$key]);
                }
            }
            return $data;            
        }
    }
    
    public function getCategory($categoryID, $limit=-1, $offset=-1){
        if($limit>-1 && $offset>-1){
            $data = $this->db->fetchAll("SELECT N.* FROM %n N,news_categories NC WHERE NC.news_id=N.id AND NC.categories_id=%i ORDER BY time DESC %lmt %ofs", $this->table, $categoryID, $limit, $offset);
        } else {
            $data = $this->db->fetchAll("SELECT N.* FROM %n N,news_categories NC WHERE NC.news_id=N.id AND NC.categories_id=%i ORDER BY time DESC", $this->table, $categoryID);
        }
        
        
        if($data === false){
            throw new \Exception("Nebyli nalezeny žádné novinky");            
        }
        else {
            foreach($data as $key => $row)
            {
                $row->categories = $this->getCategories($row->id);
            }
            return $data;            
        }
    }
    
    public function getCategories($id){
        $data = $this->db->fetchAll("SELECT * FROM %n C,%n NC WHERE C.id=NC.categories_id AND news_id=%i", "categories", $this->table."_categories", $id);        
        return $data;
    }      
}