<?php

namespace FrontModule;

use Nette\Application\UI\Presenter,
    Nette\Application\UI\Form,
    Nette\Utils\Strings;


class AlbumsPresenter extends \Presenters\BasePresenter
{
  private $album;
  public function startup(){
      parent::startup();
      $this->album = new Album();
  }
  
  public function renderDefault(){
    $data = $this->model->getAll();
    foreach($data as $albumid=>$аlbum){
         $data[$albumid]->photos = $this->album->getById($аlbum->id);
         $data[$albumid]->count = Count($data[$albumid]->photos);
         
         if($data[$albumid]->count == 0) {
          unset($data[$albumid]);
         }
    }
    $this->template->data = $data;    
  }
  public function renderDetail($id){
    $data = $this->model->getById($id);
    $data->photos = $this->album->getById($id);
    $data->count = Count($data->photos);
     
    if($data->count == 0) {
      unset($data);
    }
    
    $this->template->album = $data;    
  }
  
  
  public static $instance;

  public static function getInstance() {
      if (!isset(self::$instance)) self::$instance = new AlbumsPresenter();
      return self::$instance;
  }
  
  public static function createAlbumWidget($albumid){
    if(!is_numeric($albumid)) return "Neplatný odkaz na galerii";
    $instance = self::getInstance();
    $model = new Albums();
    $albumModel = new Album();
    $album = $model->getById($albumid);
    $album->photos = $albumModel->getById($albumid);
    $album->count = Count($album->photos);
    if($album->count == 0) return "";
    $ret = "";
    $ret .= '
    <div class="panel-heading">
              <h2 class="panel-title">'.$album->name.'</h3>
          </div>
          <div class="panel-body">
              <div class="row">
    ';
      $i = 0;
                  foreach($album->photos as $photo)
                  {
                    $i++;
                    if($i < 3){                  
                    $ret .='
                    <div class="col-xs-12 col-md-4">
                        <a href="/album-'.$albumid.'" class="thumbnail">
                            <img src="'.$photo->path.'" alt="'.$photo->description.'">
                        </a>
                    </div>
                    ';
                    }
                    if($i == $album->count){
                      $ret .='<div class="col-xs-12 col-md-4 last">
                            <a href="/album-'.$albumid.'" class="thumbnail">
                                <img src="'.$photo->path.'" alt="'.$photo->description.'">
                                <span class="label label-inverse photo-label">'.$album->count.'<br>snímků</span>
                            </a>
                        </div>
                      ';
                    }
                  }
      $ret .="                   
              </div>
          </div>";
      return $ret;
  }
  
}
