<?php

namespace FrontModule;

use Nette\Application\UI\Presenter,
    Nette\Application\UI\Form,
    Nette\Utils\Strings;


class NewsPresenter extends \Presenters\BasePresenter
{

  public function startup(){
      parent::startup();
      $this->template->poster = $this->db->fetch("SELECT * FROM poster WHERE visible=1 ORDER BY id DESC LIMIT 1;");      
  }
  
  public function renderDefault($page){
    $data = $this->model->get();
    $paginator = new \Nette\Utils\Paginator;
    $paginator->setItemCount(Count($data)); // celkový počet položek (např. článků)
    $paginator->setItemsPerPage(4); // počet položek na stránce
    $paginator->setPage($page);
    $data = $this->model->get($paginator->getItemsPerPage(), $paginator->getOffset());    
    $this->template->paginator = $paginator;
    foreach($data as $row) {
        $row->content = $this->prepareToRender($row->content, $row->id);
    }
    $this->template->data = $data;          
    \Nette\Diagnostics\Debugger::barDump($this->template->poster);
  }
  
  public function renderCategories($categories_id, $page){
    $data = $this->model->getCategory($categories_id);
    $paginator = new \Nette\Utils\Paginator;
    $paginator->setItemCount(Count($data)); // celkový počet položek (např. článků)
    $paginator->setItemsPerPage(4); // počet položek na stránce
    $paginator->setPage($page);
    $data = $this->model->getCategory($categories_id, $paginator->getItemsPerPage(), $paginator->getOffset());    
    $this->template->paginator = $paginator;
    foreach($data as $row) {
        $row->content = $this->prepareToRender($row->content, $row->id);
    }
    $this->template->data = $data;          
  }
  
  public function renderArchive($page){
    $data = $this->model->getArchive();
    $paginator = new \Nette\Utils\Paginator;
    $paginator->setItemCount(Count($data)); // celkový počet položek (např. článků)
    $paginator->setItemsPerPage(4); // počet položek na stránce
    $paginator->setPage($page);
    $data = $this->model->getArchive($paginator->getItemsPerPage(), $paginator->getOffset());    
    $this->template->paginator = $paginator;
    foreach($data as $row) {
        $row->content = $this->prepareToRender($row->content, $row->id);
    }
    $this->template->data = $data;          
  }
  
  public function renderRead($id, $name){
    $data = $this->model->getByID($id);
    $data->cont_orig = $data->content;    
    $data->content = $this->prepareToRender($data->content, $data->id);
    $this->template->row = $data;          
  } 
  
}
