<?php
require("constants.php");

use Nette\Application\Routers\Route,
	Nette\Application\Routers\RouteList,
	Nette\Application\Routers\SimpleRouter,
        Nette\Config\Configurator;   

if (@!include LIBS_DIR . '/Nette/loader.php') {
	die('Nette not found in LIBS directory. Please check your LIBS directory.');
}


$configurator = new Nette\Configurator;

if(in_array($_SERVER['REMOTE_ADDR'], $debuggers))
{
    $configurator->setDebugMode($debuggers);
}
else {
    if(MAINTENANCE == true){
        require(WWW_DIR."/.maintenance/index.html");
        exit;        
    }
    $configurator->setDebugMode($configurator::PRODUCTION);
}

$configurator->enableDebugger(__DIR__ . '/../log');



// TEMP settings
$configurator->setTempDirectory(__DIR__ . '/../temp');
$configurator->createRobotLoader()
	->addDirectory(__DIR__)
        ->addDirectory(APP_DIR)
        ->addDirectory(LIBS_DIR)
	->register();

$configurator->onCompile[] = function ($configurator, $compiler) {
    $compiler->addExtension('dibi', new Dibi\Bridges\Nette\DibiExtension22);
};

// Create Dependency Injection container from config.neon file
$configurator->addConfig(__DIR__ . '/config/config.neon', Configurator::AUTO);

$container = $configurator->createContainer();

// Setup router using mod_rewrite
	$router = $container->getService('router');
	$router[] = new Route('index.php', 'Front:Default:default', Route::ONE_WAY);

	$router[] = $adminRouter = new RouteList('Admin');
	$adminRouter[] = new Route('admin/<presenter>/<action>', 'Default:default');
        
        $router[] = $eshopRouter = new RouteList('Eshop');
	$eshopRouter[] = new Route('eshop/<presenter>/<action>', 'Default:default');


	$container->router[] = $frontRouter = new RouteList('Front');     
  $frontRouter[] = $route = new \Addons\FilterRoute('stranka-<id>',
                            array(
                                'presenter' => 'Pages',
                                'action' => 'default',
                                'id' => NULL
                    ));
   $frontRouter[] = $route = new \Addons\FilterRoute('album-<id>',
                            array(
                                'presenter' => 'albums',
                                'action' => 'detail',
                                'id' => NULL
                    ));
   $frontRouter[] = $route = new \Addons\FilterRoute('alba',
                            array(
                                'presenter' => 'albums',
                                'action' => 'default',
                                'id' => NULL
                    ));
                      
  
  /* NOVINKY ROUTER */
  $frontRouter[] = $route = new \Addons\FilterRoute('novinka-<id>-<name>',
                            array(
                                'presenter' => 'News',
                                'action' => 'read',
                                'id' => NULL,
                                'name' => NULL
                    ));
  $frontRouter[] = $route = new \Addons\FilterRoute('[novinky-<page>]',
                            array(
                                'presenter' => 'news',
                                'action' => 'default',
                                'page' => 1
                    ));
  
  $frontRouter[] = $route = new \Addons\FilterRoute('[kategorie-novinek-<categories_id>-<page>]',
                            array(
                                'presenter' => 'news',
                                'action' => 'categories',
                                'page' => 1,
                                'cagetogies_id' => 0
                    ));
  
  
  /* OSTATNÍ ROUTERY*/ 
  $frontRouter[] = $route = new \Addons\FilterRoute('<presenter>/<action>/<id>',
                            array(
                                'presenter' => 'news',
                                'action' => 'default',
                                'id' => NULL
                    ));
  // Setup router !using mod_rewrite 
//	$container->addService('router', new SimpleRouter('Front:Default:default'));

  
$container->application->errorPresenter = 'Front:Error';
  
  
$container->getService('application')->run();
                       