<?php
use Nette\Application\UI;

class GridFactory extends Nette\Object
{

    public function __construct(){}
    
    public function create($self, $generateLink=false)
    {
        $grid = new \Nextras\Datagrid\Datagrid;
        $grid->addCellsTemplate(APP_DIR.'/AdminModule/templates/@DataGrid-columns-default.latte');
        $grid->setDatasourceCallback(function($filter, $order) use($self, $generateLink) {
            $filters = array();
            foreach ($filter as $k => $v) {
                if ($k == 'id' || is_array($v))
                    $filters[$k] = $k."=".$v;
                else
                    $filters[$k] = $k." LIKE '%$v%'";
            }                          
        
            $selection = $self->model->getDataSource($filters);
            if($generateLink===true){
              foreach($selection as $row){
                $row->url=$self->generateURL($row->id);
              }
            }
            if ($order[0])
                $selection->order(implode(' ', $order));
        
            return $selection;
        });

        return $grid;
    }
    public function createFilterForm(){
      $form = new \Nette\Forms\Container;
      $form->addSubmit('filter', 'Filtrovat')->getControlPrototype()->class = 'btn btn-primary';
      $form->addSubmit('cancel', 'Resetovat')->getControlPrototype()->class = 'btn';    
      return $form;
    }
}