<?php
use Nette\Application\UI;

class PagesNewEditForm extends Nette\Object
{
    private $db;
    private $form;
    

    public function __construct(DibiConnection $db, FormFactory $form)
    {
        $this->db = $db;
        $this->form = $form;
    }

    public function create($duplicate = false)
    {
        $form = $this->form->create();
        $form->addText('title', 'Název:')->addRule(UI\Form::FILLED, 'Zadejte Název stránky');
        if(!$duplicate){
          $form->addText('keywords', ' [SEO] Klíčová slova:')->addRule(UI\Form::FILLED, 'Vyplňte klíčová slova');
          $form->addText('description', '[SEO] Krátky Popis:')->addRule(UI\Form::FILLED, 'Vyplňte krátky popis');
          $form->addTextArea('content', 'Obsah stránky');
        }
        $form->addHidden('id', 'id');
        $form->onSuccess[] = $this->processForm;
        $form->addSubmit('submit', 'Odeslat'); 
        return $form;
    }

    public function processForm($form)
    {
        /*
         *  Ukládání dat probíhá zde
         */
    }
}