<?php

namespace Lambda;

use Nette\Application\UI\Control;



class ControlNavigation extends Control
{
    private $source;  
    private $id;
    
    public function __construct($id, $source){
        $this->source = $source;
        $this->id = $id;
    }
    
    
    public function render(){
      $this->template->setFile(__DIR__ . '/Navigation.latte');
      
      $order = $this->getOrder($this->source);
      $this->template->nav = $this->navRender($this->source, $order);
       
  		$this->template->render();
    }
    
       
    private $toSkip = array();
                
    private function SearchChild($source, $parentID){        
        $node = array();
        foreach($source as $row){                 
          if($row->parent_id==$parentID){
            if(isset($this->toSkip[$parentID])) continue;
            $node[$row->id] = $this->SearchChild($source, $row->id);
            $this->toSkip[$row->id]=true;
          }
        }
        return $node;
    }

    private function renderChild($source, $order, $parentID){   
        $str = "<ul style='list-style-type:none;'>";
        foreach($order as $id=>$row){
           $str.="<li style='padding-left: 30px;'>".$this->getLink($source, $id)."".$this->renderChild($source, $order[$id], $id)."</li>";
        }
        $str .="</ul>";
        return $str;
    }
    
    private function navRender($source, $order){     
        $str = "<ul style='list-style-type:none;font-size: 18px;'>"; 
        $str .="<li><span class='badge badge-success'><a style='color: #FFF;' href=".$this->presenter->link('new', array("id"=>0, "navid"=>$this->id))."><i class='fa fa-plus'></i></a></span></li>";
        foreach($order as $id=>$row){
            /*if(!count($row)){
               $str.= "<li>".$this->getLink($source, $id)."</li>";
            } else {*/
               $str.="<li style='padding-left: 30px;'>".$this->getLink($source, $id)."".$this->renderChild($source, $order[$id], $id)."</li>";
            //}
        }
        $str .="</ul>";
        return $str;
    }
    
    private function getLink($source, $id){
        foreach($source as $row){
            if($row->id == $id) {
                $str = "";
                $str.=''.$row['content']." [ ";
                if($row->pos_id>0) $str.="<a href='".$this->presenter->link('move', array("id"=>$id,"do"=>0, "navid"=>$this->id))."'><i class='fa fa-arrow-up'></i></a> ";
                else $str.="<i class='fa fa-arrow-up' style='opacity: 0.25;'></i> "; 
                
                $isValid = false;
                
                foreach($source as $r){
                  if($r->id != $id && $r->parent_id == $row->parent_id){
                    if($r->pos_id>$row->pos_id) $isValid = true;
                  } 
                }
                
                if($isValid) $str.="<a href='".$this->presenter->link('move', array("id"=>$id,"do"=>1, "navid"=>$this->id))."'><i class='fa fa-arrow-down'></i></a> ";
                else $str.="<i class='fa fa-arrow-down' style='opacity: 0.25;'></i> "; 
                if($row->parent_id>0) $str.="<a href='".$this->presenter->link('move', array("id"=>$id,"do"=>2, "navid"=>$this->id))."'><i class='fa fa-arrow-left'></i></a> ";
                else $str.="<i class='fa fa-arrow-left' style='opacity: 0.25;'></i> "; 
                if($row->pos_id>0) $str.="<a href='".$this->presenter->link('move', array("id"=>$id,"do"=>3, "navid"=>$this->id))."'><i class='fa fa-arrow-right'></i></a>";
                else $str.="<i class='fa fa-arrow-right' style='opacity: 0.25;'></i> "; 
                
                $str.=" <span class='badge badge-success'><a style='color: #FFF;' href=".$this->presenter->link('new', array("id"=>$id, "navid"=>$this->id))."><i class='fa fa-plus'></i></a></span>";
                $str.=" <span class='badge badge-danger'><a style='color: #FFF;' href=".$this->presenter->link('delete', array("id"=>$id, "navid"=>$this->id))."><i class='fa fa-times'></i></a></span>";
                $str.=" <span class='badge badge-warning'><a style='color: #FFF;' href=".$this->presenter->link('edit', array("id"=>$id, "navid"=>$this->id))."><i class='fa fa-edit'></i></a></span>";
                
                $str.=" ]";
                return $str;
            }
        }
    }

    private function getOrder($source){ 
        $node = array();
        foreach($source as $row){
          if(isset($this->toSkip[$row->id])) continue;
          $node[$row->id] = $this->SearchChild($source, $row->id);  
        }
        return $node;
    }     
}      